import { BlockStore } from "@dao-xyz/libp2p-direct-block";
import { Cache } from "@dao-xyz/cache";
import { Entry } from "./entry.js";
export declare class EntryIndex<T> {
    _cache: Cache<Entry<T> | null>;
    _store: BlockStore;
    _init: (entry: Entry<T>) => void;
    _index: Set<string>;
    constructor(properties: {
        store: BlockStore;
        init: (entry: Entry<T>) => void;
        cache: Cache<Entry<T>>;
    });
    set(v: Entry<T>, toMultihash?: boolean): Promise<void>;
    get(k: string, options?: {
        replicate?: boolean;
        timeout?: number;
    }): Promise<Entry<T> | undefined>;
    private getFromStore;
    delete(k: string): Promise<void>;
}
