import { Entry } from "./entry";
import LocalStore from "@dao-xyz/lazy-level";
export declare const logger: import("pino").Logger<import("pino").LoggerOptions | import("pino").DestinationStream>;
export declare class CachedValue {
}
export declare class CachePath {
    path: string;
    constructor(path: string);
}
export declare class UnsfinishedReplication {
    hashes: string[];
    constructor(opts?: {
        hashes: string[];
    });
}
export declare class HeadsCacheToSerialize {
    heads: string[];
    last?: string;
    counter: bigint;
    constructor(heads: string[], counter: bigint, last?: string);
}
interface HeadsIndex {
    id: Uint8Array;
    size: number;
    has(cid: string): boolean;
}
export declare class HeadsCache<T> {
    headsPath: string;
    removedHeadsPath: string;
    initialized: boolean;
    private _headsPathCounter;
    private _lastHeadsPath?;
    private _lastHeadsCount;
    private _lastRemovedHeadsPath?;
    private _lastRemovedHeadsCount;
    private _cache;
    private _cacheWriteQueue;
    private _loaded;
    private _index;
    constructor(index: HeadsIndex);
    init(cache: (name: string) => Promise<LocalStore> | LocalStore): Promise<this>;
    get loaded(): boolean;
    private _updateCachedHeads;
    idle(): Promise<void>;
    getCachedHeads(lastHeadsPath?: string | undefined, lastRemovedHeadsPath?: string | undefined): Promise<string[]>;
    get cache(): LocalStore;
    get closed(): boolean;
    close(): Promise<void>;
    /**
     * Drops a database and removes local data
     */
    drop(): Promise<void>;
    private _loadHeads;
    load(): Promise<string[]>;
    loadLastHeadsPath(): Promise<void>;
    getCachedHeadsCount(headPath?: string): Promise<bigint>;
    waitForHeads(): Promise<void | string[]>;
    queue(changes: {
        added?: (Entry<T> | string)[];
        removed?: (Entry<T> | string)[];
    }, reset?: boolean): Promise<void>;
}
export {};
