import { Entry } from "./entry.js";
import { BlockStore } from "@dao-xyz/libp2p-direct-block";
import LocalStore from "@dao-xyz/lazy-level";
export declare class Snapshot {
    id: Uint8Array;
    heads: string[];
    size: bigint;
    values: Entry<any>[];
    constructor(props?: {
        id: Uint8Array;
        heads: string[];
        size: bigint;
        values: Entry<any>[];
    });
}
export declare const save: <T>(snapshotPath: string, blockstore: BlockStore, cache: LocalStore, log: {
    id: Uint8Array;
    getHeads: () => Promise<string[]>;
    getValues: () => Entry<T>[] | Promise<Entry<T>[]>;
}) => Promise<string>;
export declare const load: (hash: string, blockstore: BlockStore) => Promise<Snapshot>;
export declare const loadFromCache: (path: string, blockstore: BlockStore, cache: LocalStore) => Promise<Snapshot>;
