import { Entry } from "./entry.js";
import { EntryNode, Values } from "./values.js";
export type TrimToLengthOption = {
    type: "length";
    to: number;
    from?: number;
};
export type TrimToByteLengthOption = {
    type: "bytelength";
    to: number;
    from?: number;
};
export type TrimToTime = {
    type: "time";
    maxAge: number;
};
export type TrimCondition = TrimToByteLengthOption | TrimToLengthOption | TrimToTime;
export type TrimCanAppendOption = {
    filter?: {
        canTrim: (gid: string) => Promise<boolean> | boolean;
        cacheId?: () => string;
    };
};
export type TrimOptions = TrimCanAppendOption & TrimCondition;
interface Log<T> {
    values: () => Values<T>;
    deleteNode: (node: EntryNode) => Promise<Entry<T> | undefined>;
}
export declare class Trim<T> {
    private _trim?;
    private _canTrimCacheLastNode;
    private _trimLastHead;
    private _trimLastTail;
    private _trimLastOptions;
    private _trimLastSeed;
    private _canTrimCacheHashBreakpoint;
    private _log;
    private _queue;
    constructor(log: Log<T>, options?: TrimOptions);
    deleteFromCache(entry: Entry<T>): void;
    get options(): TrimOptions | undefined;
    private trimTask;
    /**
     * @param options
     * @returns deleted entries
     */
    trim(option?: TrimOptions | undefined): Promise<Entry<T>[]>;
}
export {};
