import { Entry } from "./entry";
import { ISortFunction } from "./log-sorting";
import yallist from "yallist";
import { EntryIndex } from "./entry-index";
interface Value {
    hash: string;
    gid: string;
    byteLength: number;
}
export type EntryNode = yallist.Node<Value>;
export declare class Values<T> {
    /**
     * Keep track of sorted elements in descending sort order (i.e. newest elements)
     */
    private _values;
    private _sortFn;
    private _byteLength;
    private _entryIndex;
    constructor(entryIndex: EntryIndex<T>, sortFn: ISortFunction, entries?: Entry<T>[]);
    toArray(): Promise<Entry<T>[]>;
    get head(): yallist.Node<Value> | null;
    get tail(): yallist.Node<Value> | null;
    get length(): number;
    private _putPromise;
    put(value: Entry<T>): Promise<any>;
    _put(value: Entry<T>): Promise<void>;
    delete(value: Entry<T> | string): Promise<void>;
    deleteNode(node: EntryNode): void;
    pop(): Value | undefined;
    get byteLength(): number;
    getEntry(node: EntryNode): Promise<Entry<T> | undefined>;
}
export {};
